package de.jpainfo.model;

import java.util.HashSet;

import java.util.Set;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;

@Entity
public class Angestellter {

	@Id @GeneratedValue
	private Integer id;
	private String vorname;
	private String nachname;
	
	
	@OneToMany(mappedBy = "vorgesetzter", cascade = CascadeType.ALL)
	private Set<Angestellter> mitarbeiter;
	
	@ManyToOne
	@JoinColumn(name = "vorgesetzter")
	private Angestellter vorgesetzter;
	
	
	public Angestellter() {
		mitarbeiter = new HashSet<Angestellter>();
	}
	
	
	public Angestellter(String vorname, String nachname) {
		this();
		this.vorname = vorname;
		this.nachname = nachname;
	}


	public void neuerMitarbeiter(Angestellter angestellter) {
		this.getMitarbeiter().add(angestellter);
		angestellter.setVorgesetzter(this);
	}
	
	
	public boolean isChef() {
		return vorgesetzter == null;
	}
	
	
	public int anzahlMitarbeiter() {
		return mitarbeiter.size();
	}

	
	public boolean isAbteilungsleiter() {
		return anzahlMitarbeiter() != 0;
	}
	


	// Getter und Setter
	public Integer getId() {
		return id;
	}

	
	public String getVorname() {
		return vorname;
	}
	public void setVorname(String vorname) {
		this.vorname = vorname;
	}
	
	
	public String getNachname() {
		return nachname;
	}
	public void setNachname(String nachname) {
		this.nachname = nachname;
	}


	public Set<Angestellter> getMitarbeiter() {
		return mitarbeiter;
	}


	public void setMitarbeiter(Set<Angestellter> mitarbeiter) {
		this.mitarbeiter = mitarbeiter;
	}


	public Angestellter getVorgesetzter() {
		return vorgesetzter;
	}


	public void setVorgesetzter(Angestellter vorgesetzter) {
		this.vorgesetzter = vorgesetzter;
	}

	
	
}
